#ifndef GIZE_MASK_H
#define GIZE_MASK_H

#include "TableCsv.h"

class GizeMask {
    bool cell_5, firstLine, noSplitting, oneMore, preedit, scope, serialNumber, ticketForm, toGize, whoText;
    bool unbroken[MASK_COUNT];
    const int ALL_QP_SIZE, LINES, NEW_LINE_LENGTH;
    const std::string ALL_QP, CLOSE_BRACKET, COMMA_GAP, EMPTY, FREE, GAP, GAP_LINES, GAP_SLASH, GAP_SLASH_SLASH, ID_COLON, QP, SLASH, NEW_LINE, SPACE, TRACE_0, TRACE_1, TRACE_2, TRACE_3, TRACE_4, TRACE_5, TRACE_6, TRACE_7;
    int count, lines, split, rowCount;
    int mask[MASK_COUNT];
    int shift[10];
    std::string ANCHOR, error, fileName, FULL_PATH_NAME, id, list_of_items, matrixStatusBarText, res_no, textName, whose;
    std::string a[DRAW_ARRAY_SIZE];
    std::string draw[DRAW_ARRAY_SIZE];
    std::string m[ MANAGE_TEXT_LINE_COUNT + 1 ];
    std::string trace[MASK_COUNT];
    std::stringstream *buffer;
    std::stringstream *combos;
    UnbrokenLine *ul;

    bool allQP(char *p) {
        using namespace std;

        string s(p);
        if(scope) {
            return true;
        }

        int q = s.find(ALL_QP);
        if(q != string::npos) {
            scope = true;
        }

        return scope;
    }

    bool allQP(std::string & s) {
        using namespace std;

        if(scope) {
            return true;
        }

        int q = s.find(ALL_QP);
        if(q != string::npos) {
            scope = true;
        }

        return scope;
    }

    void add(std::string & s) {
        *combos << s << NEW_LINE;
        count += 1;
    }

    void clear(std::string & i, std::string & re, std::string & s, int r) {
        delete combos;
        combos = new std::stringstream();
        count = 0;
        scope = false;

        id = i;
        res_no = re;
        split = r;
        whose = s;
    }

    void listing(std::string & extra) {
        std::string c = combos->str();
        *buffer << whose << NEW_LINE << c << extra;
    }

    bool openSaveClose(std::string & fileName);
    int and_mask_equals_mask(int a);
    std::string assembling(std::string & whichLine);
    void dividing(char *p, char *to, int to_array_size);
    void dividing(std::string & s, char *to, int to_array_size);
    void listing();

public:
    ~GizeMask() {
        delete buffer;
        delete combos;
    }

    std::string inquiry() const {
        return error;
    }

    std::string saved() const {
        return textName;
    }

    bool run(std::string & fileName);
    GizeMask(int l, bool c, bool n, bool s, bool w);
    void twoMatrices(std::string secondLine, std::string whoTextLine1);
    void illustrateUnbrokenLines(); // gizeMain.cpp
    void unbrokenLines();
};

#endif // GIZE_MASK_H
