CC        = bcc32
LINKER    = ilink32

INCLUDE = -I"C:\borland\bcc55\Include"
LIB     = /L"C:\borland\bcc55\Lib"

CFLAGS = -O2 -w 
LFLAGS = /Tpe /c /ap

TARGET = gize.exe
OBJS   = datefollowed.obj dividing.obj drafo.obj editcount.obj exclude.obj gizemain.obj gizemask.obj numbered.obj os-specific.obj tablecsv.obj timename.obj triplet.obj 

ALL : $(TARGET)

datefollowed.obj: DateFollowed.cpp
	$(CC) $(INCLUDE) -c DateFollowed.cpp
dividing.obj: Dividing.cpp
	$(CC) $(INCLUDE) -c Dividing.cpp
drafo.obj: Drafo.cpp
	$(CC) $(INCLUDE) -c Drafo.cpp
editcount.obj: EditCount.cpp
	$(CC) $(INCLUDE) -c EditCount.cpp
exclude.obj: Exclude.cpp
	$(CC) $(INCLUDE) -c Exclude.cpp
gizemain.obj: gizeMain.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c gizeMain.cpp
gizemask.obj: GizeMask.cpp
	$(CC) $(INCLUDE) -c GizeMask.cpp
numbered.obj: numbered.cpp
	$(CC) $(INCLUDE) -c numbered.cpp
os-specific.obj: OS-specific.cpp
	$(CC) $(INCLUDE) -c OS-specific.cpp
tablecsv.obj: TableCsv.cpp
	$(CC) $(INCLUDE) -c TableCsv.cpp
timeName.obj: TimeName.cpp
	$(CC) $(INCLUDE) -c TimeName.cpp
triplet.obj: Triplet.cpp
	$(CC) $(INCLUDE) -c Triplet.cpp

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0x32.obj,$(TARGET),,cw32.lib import32.lib,,

clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
	del *.res
