#ifndef EDIT_COUNT_H
#define EDIT_COUNT_H

#include "TableCsv.h"
#include "Drafo.h"
#include "Exclude.h"
#include "GizeMask.h"
#include "Triplet.h"

class EditCount {
    bool cell_5, csv, firstLine, noSplitting, preedit, quit, serialNumber, ticketForm, toGize, whoText;
    const int LINES;
    const std::string CLOSE_BRACKET, DRAFO_CSV, EXCLUDE_TEXT, m0, m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12, m13, m14, m15, m16, m17, m18, ZERO;
    int lines, NEW_LINE_LENGTH, rowCount;
    std::string error, fileName, FULL_PATH_NAME, list_of_items, NEW_LINE, textName;
    std::string m[ MANAGE_TEXT_LINE_COUNT + 1 ];

    bool readManageText();
    bool testDrafoCsv();
    void stringArrayToValues();

public:
    std::string inquiry() const {
        return error;
    }

    std::string saved() const {
        return textName;
    }

    bool editCount();
    bool preediting();
    bool setting(std::string & f, std::string & fi, std::string & l, int li, bool c, bool cs, bool fir, bool n, bool p, bool q, bool s, bool t, bool w);
    ~EditCount(){}
    EditCount();
};

bool backupToProduceToText();
bool detectingMatrix(std::string & d, std::string & l, bool f, bool s, bool w);
bool readFilesBeforeCreatingWindows(std::string & commandLine);
bool readingToProduceWhoText(std::string & fileName);
bool removeTemporaryFiles();
void guide(bool comments);

#endif // EDIT_COUNT_H
